'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.batchedUpdatesMiddleware = batchedUpdatesMiddleware;
exports.batchedUpdates = batchedUpdates;

var _reactAddons = require('react/addons');

function batchedUpdatesMiddleware() {
  return function (next) {
    return function (action) {
      return _reactAddons.addons.batchedUpdates(function () {
        return next(action);
      });
    };
  };
}

function batchedUpdates(next) {
  return function () {
    var store = next.apply(undefined, arguments);
    return _extends({}, store, {
      dispatch: batchedUpdatesMiddleware()(store.dispatch)
    });
  };
}